﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ch09_components_td
{
    public partial class AlarmComponent : Component
    {
        public AlarmComponent()
        {
            InitializeComponent();
        }

        public AlarmComponent(IContainer container)
        {
            container.Add(this);
            InitializeComponent();
            timerAlarm.Enabled = true;
            timerAlarm.Interval = 1000;
            timerAlarm.Tick += timerAlarm_Tick;
        }

        public delegate void AlarmSoundedEventHandler(
            object sender, AlarmEventArgs e);

        public event AlarmSoundedEventHandler AlarmSounded;

        void timerAlarm_Tick(object sender, EventArgs e)
        {
            double seconds = (DateTime.Now - this.alarm).TotalSeconds;
            if (seconds >= 0 && seconds <= 1)
            {
               DateTime alarm = this.alarm;
               this.alarm = DateTime.MaxValue;
               if (AlarmSounded != null)
               {
                   AlarmSounded(this, new AlarmEventArgs(alarm));
               }
            }
        }

        DateTime alarm = DateTime.MaxValue;

        public DateTime Alarm
        {
            get { return alarm; }
            set { alarm = value; }
        }


        public DateTime DelayAlarm(double seconds)
        {
            if (this.alarm < DateTime.MaxValue.AddSeconds(-seconds))
            {
                this.alarm = alarm.AddSeconds(seconds);
            }
            return alarm;
        }
    }
}
